<?php

namespace EventPortal\Domain\ActionList\Models;

use EventPortal\Domain\User\Models\User;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Support\Facades\Auth;

class ActionList extends Model
{
    public function tasks(): HasMany
    {
        return $this->hasMany(Task::class);
    }

    public function complete(?User $user = null): void
    {
        $this->tasks()->incompleted()->each(function (Task $task) use ($user): void {
            $task->complete($user ?? Auth::user());
        });
    }

    public function getNumOutstandingTasksAttribute(): int
    {
        return (int) $this->tasks()->incompleted()->count();
    }
}
